"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BrowserlessApi = void 0;
class BrowserlessApi {
    constructor() {
        this.displayName = 'Browserless Credentials API';
        this.name = 'browserlessApi';
        this.documentationUrl = 'https://docs.browserless.io/docs/token.html#docsNav';
        this.properties = [
            {
                displayName: 'Browserless URL',
                name: 'url',
                type: 'string',
                default: '',
            },
            {
                displayName: 'Token',
                name: 'token',
                type: 'string',
                typeOptions: {
                    password: true,
                },
                default: '',
            },
        ];
        this.authenticate = {
            type: 'generic',
            properties: {
                qs: {
                    token: '={{ $credentials.token }}',
                },
            },
        };
        this.test = {
            request: {
                baseURL: '={{ $credentials.url }}',
                encoding: 'json',
                url: '/content',
                method: 'POST',
                qs: {
                    token: '={{ $credentials.token }}',
                },
                body: {
                    url: 'https://example.com/',
                },
            },
        };
    }
}
exports.BrowserlessApi = BrowserlessApi;
//# sourceMappingURL=BrowserlessApi.credentials.js.map