"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Browserless = void 0;
const n8n_workflow_1 = require("n8n-workflow");
const Browserless_node_1 = require("./v1/Browserless.node");
const Browserless_node_2 = require("./v2/Browserless.node");
class Browserless extends n8n_workflow_1.VersionedNodeType {
    constructor() {
        const baseDescription = {
            displayName: 'Browserless',
            name: 'browserless',
            icon: 'file:browserless.svg',
            group: ['transform'],
            subtitle: '={{$parameter["operation"] + ": " + $parameter["resource"]}}',
            description: 'Interact with Browserless API',
            version: [1, 2, 3],
            defaultVersion: 2,
        };
        const nodeVersions = {
            1: new Browserless_node_1.Browserless(baseDescription),
            2: new Browserless_node_2.Browserless(baseDescription),
        };
        super(nodeVersions, baseDescription);
    }
}
exports.Browserless = Browserless;
//# sourceMappingURL=Browserless.node.js.map