import { IAllExecuteFunctions, IDataObject, IExecuteFunctions, IHttpRequestMethods, IHttpRequestOptions, IN8nHttpFullResponse, IN8nHttpResponse, INodeProperties, INodePropertyCollection, INodePropertyOptions } from 'n8n-workflow';
import { BrowserlessApiRequestContentOptions, BrowserlessApiRequestFnOptions, BrowserlessApiRequestPdfOptions, BrowserlessApiRequestScrapeOptions, BrowserlessApiRequestScreenshotOptions, BrowserlessApiResponseScrape, BrowserlessApiResponseScrapeData, BrowserlessApiResponseScrapeDataFlat, BrowserlessCommonOptions } from './types';
export declare function browserlessApiRequest(this: IAllExecuteFunctions, method: IHttpRequestMethods, endpoint: string, body?: IDataObject, qs?: IDataObject, extradOptions?: Partial<IHttpRequestOptions>): Promise<IN8nHttpFullResponse | IN8nHttpResponse>;
export declare function browserlessApiRequestContent(this: IExecuteFunctions, options: BrowserlessApiRequestContentOptions): Promise<IN8nHttpFullResponse>;
export declare function browserlessApiRequestScrape(this: IExecuteFunctions, options: BrowserlessApiRequestScrapeOptions): Promise<BrowserlessApiResponseScrape>;
export declare function browserlessApiRequestFuction(this: IExecuteFunctions, options: BrowserlessApiRequestFnOptions): Promise<IN8nHttpFullResponse | IN8nHttpResponse>;
export declare function browserlessApiRequestPdf(this: IExecuteFunctions, options: BrowserlessApiRequestPdfOptions): Promise<import("n8n-workflow").IBinaryData>;
export declare function browserlessApiRequestScreenshot(this: IExecuteFunctions, options: BrowserlessApiRequestScreenshotOptions): Promise<import("n8n-workflow").IBinaryData>;
export declare function getCommonOptions(this: IExecuteFunctions, i: number): IDataObject;
export declare function getNodeCommoonOptions(this: IExecuteFunctions): BrowserlessCommonOptions;
export declare function composeArrayToMap(array: IDataObject[], key: string, value: string): IDataObject;
export declare function omitEmptyProps(obj: IDataObject): IDataObject;
export declare function prepareBinaryResponse(this: IExecuteFunctions, res: IN8nHttpFullResponse, key: string): Promise<import("n8n-workflow").IBinaryData>;
export declare function parseBrowserOptions(rawOption: IDataObject): IDataObject;
export declare function parseFixedCollectionOptions(descriptor: INodeProperties, rawOption: IDataObject): import("n8n-workflow").GenericValue;
export declare function parseCollectionOptions(descriptor: INodeProperties, rawOption: IDataObject): IDataObject;
export declare function isINodeProperties(descriptor: INodeProperties | INodePropertyOptions | INodePropertyCollection): descriptor is INodeProperties;
export declare function flaternScrapedResults(this: IExecuteFunctions, options: BrowserlessApiRequestScrapeOptions, data: BrowserlessApiResponseScrapeData): BrowserlessApiResponseScrapeDataFlat;
