"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.browserlessApiRequest = browserlessApiRequest;
exports.browserlessApiRequestContent = browserlessApiRequestContent;
exports.browserlessApiRequestScrape = browserlessApiRequestScrape;
exports.browserlessApiRequestFuction = browserlessApiRequestFuction;
exports.browserlessApiRequestPdf = browserlessApiRequestPdf;
exports.browserlessApiRequestScreenshot = browserlessApiRequestScreenshot;
exports.getCommonOptions = getCommonOptions;
exports.getNodeCommoonOptions = getNodeCommoonOptions;
exports.composeArrayToMap = composeArrayToMap;
exports.omitEmptyProps = omitEmptyProps;
exports.prepareBinaryResponse = prepareBinaryResponse;
exports.parseBrowserOptions = parseBrowserOptions;
exports.parseFixedCollectionOptions = parseFixedCollectionOptions;
exports.parseCollectionOptions = parseCollectionOptions;
exports.isINodeProperties = isINodeProperties;
exports.flaternScrapedResults = flaternScrapedResults;
const n8n_workflow_1 = require("n8n-workflow");
const schems = __importStar(require("./chemas/browserless-api.schema"));
const BrowserlessDescriptions_1 = require("./BrowserlessDescriptions");
async function browserlessApiRequest(method, endpoint, body = {}, qs = {}, extradOptions = {}) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p;
    const credentials = (await this.getCredentials('browserlessApi'));
    const options = {
        ...extradOptions,
        method,
        body,
        qs: {
            ...qs,
            token: credentials.token,
        },
        baseURL: credentials.url,
        url: `${endpoint}`,
        json: true,
    };
    if (Object.keys(qs).length === 0) {
        delete options.qs;
    }
    if (Object.keys(body).length === 0) {
        delete options.body;
    }
    try {
        return (await this.helpers.httpRequestWithAuthentication.call(this, 'browserlessApi', options));
    }
    catch (error) {
        const errorDetails = {
            ...error,
            consig: (_a = error === null || error === void 0 ? void 0 : error.cause) === null || _a === void 0 ? void 0 : _a.config,
            request: ((_b = error === null || error === void 0 ? void 0 : error.cause) === null || _b === void 0 ? void 0 : _b.request)
                ? {
                    path: (_d = (_c = error === null || error === void 0 ? void 0 : error.cause) === null || _c === void 0 ? void 0 : _c.request) === null || _d === void 0 ? void 0 : _d.path,
                    _headers: (_f = (_e = error === null || error === void 0 ? void 0 : error.cause) === null || _e === void 0 ? void 0 : _e.request) === null || _f === void 0 ? void 0 : _f._headers,
                    data: (_j = (_h = (_g = error === null || error === void 0 ? void 0 : error.cause) === null || _g === void 0 ? void 0 : _g.request) === null || _h === void 0 ? void 0 : _h.config) === null || _j === void 0 ? void 0 : _j.data,
                }
                : null,
            response: ((_k = error === null || error === void 0 ? void 0 : error.cause) === null || _k === void 0 ? void 0 : _k.request)
                ? {
                    data: (_m = (_l = error === null || error === void 0 ? void 0 : error.cause) === null || _l === void 0 ? void 0 : _l.response) === null || _m === void 0 ? void 0 : _m.data,
                    status: (_p = (_o = error === null || error === void 0 ? void 0 : error.cause) === null || _o === void 0 ? void 0 : _o.response) === null || _p === void 0 ? void 0 : _p.status,
                }
                : null,
        };
        throw new n8n_workflow_1.NodeApiError(this.getNode(), errorDetails);
    }
}
async function browserlessApiRequestContent(options) {
    const body = {
        ...options.options,
    };
    const { error, value } = schems.content.validate(body);
    if (error) {
        throw error;
    }
    const response = (await browserlessApiRequest.call(this, 'POST', '/content', value, options.common.browserOptions));
    return response;
}
async function browserlessApiRequestScrape(options) {
    const body = {
        ...options.options,
    };
    const { error, value } = schems.scrape.validate(body);
    if (error) {
        throw error;
    }
    const response = await browserlessApiRequest.call(this, 'POST', '/scrape', value, options.common.browserOptions);
    return response;
}
async function browserlessApiRequestFuction(options) {
    const body = {
        ...options.options,
    };
    const { error, value } = schems.fn.validate(body);
    if (error) {
        throw error;
    }
    const response = await browserlessApiRequest.call(this, 'POST', '/function', value, options.common.browserOptions);
    return response;
}
async function browserlessApiRequestPdf(options) {
    const body = {
        ...options.options,
    };
    const { error, value } = schems.pdf.validate(body);
    if (error) {
        throw error;
    }
    const timeout = options.common.browserOptions.keepalive
        ? options.common.browserOptions.keepalive
        : 60000;
    const response = (await browserlessApiRequest.call(this, 'POST', '/pdf', value, options.common.browserOptions, {
        encoding: 'arraybuffer',
        json: false,
        returnFullResponse: true,
        timeout,
    }));
    const binaryData = await prepareBinaryResponse.call(this, response, 'data.pdf');
    return binaryData;
}
async function browserlessApiRequestScreenshot(options) {
    const body = {
        ...options.options,
    };
    const { error, value } = schems.screenshot.validate(body);
    if (error) {
        throw error;
    }
    const response = (await browserlessApiRequest.call(this, 'POST', '/screenshot', value, options.common.browserOptions, {
        encoding: 'arraybuffer',
        json: false,
        returnFullResponse: true,
    }));
    const binaryData = await prepareBinaryResponse.call(this, response, 'data.png');
    return binaryData;
}
function getCommonOptions(i) {
    let options = {};
    try {
        const addition = this.getNodeParameter('addition', i);
        options = parseCollectionOptions(BrowserlessDescriptions_1.browserlessPageOptionsFileds, addition);
        if (options['setExtraHTTPHeaders']) {
            options['setExtraHTTPHeaders'] = composeArrayToMap(options['setExtraHTTPHeaders'], 'name', 'value');
        }
        options['setExtraHTTPHeaders'] = {
            ...options['setExtraHTTPHeaders'],
            'cache-control': 'no-cache',
        };
        if (options['addScriptTag']) {
            options['addScriptTag'] = Array.from(options['addScriptTag']).map((tag) => omitEmptyProps(tag));
        }
        if (options['waitFor']) {
            options['waitFor'] = Number.isNaN(+options['waitFor'])
                ? options['waitFor']
                : +options['waitFor'];
        }
    }
    catch (e) {
    }
    return options;
}
function getNodeCommoonOptions() {
    const browserOptionsRaw = this.getNodeParameter('browserOptions', 0);
    const browserOptions = parseBrowserOptions(browserOptionsRaw);
    return {
        browserOptions,
    };
}
function composeArrayToMap(array, key, value) {
    const options = {};
    for (const item of array) {
        if (typeof item[key] === 'string') {
            options[item[key]] = item[value];
        }
    }
    return options;
}
function omitEmptyProps(obj) {
    const options = {};
    for (const [key, value] of Object.entries(obj)) {
        if (!!value) {
            options[key] = value;
        }
    }
    return options;
}
async function prepareBinaryResponse(res, key) {
    const binaryData = await this.helpers.prepareBinaryData(Buffer.from(res.body));
    return binaryData;
}
function parseBrowserOptions(rawOption) {
    var _a;
    const options = {};
    for (const option of (_a = BrowserlessDescriptions_1.browserlessBrowserOptionsFields === null || BrowserlessDescriptions_1.browserlessBrowserOptionsFields === void 0 ? void 0 : BrowserlessDescriptions_1.browserlessBrowserOptionsFields.options) !== null && _a !== void 0 ? _a : []) {
        if (typeof rawOption[option.name] === 'boolean') {
            options[option.name] = rawOption[option.name] ? 'true' : 'false';
        }
        else if (rawOption[option.name]) {
            options[option.name] = rawOption[option.name];
        }
    }
    return options;
}
function parseFixedCollectionOptions(descriptor, rawOption) {
    if (descriptor.type !== 'fixedCollection') {
        return rawOption;
    }
    if (descriptor.typeOptions && descriptor.typeOptions.multipleValues) {
        const [firstValue] = Object.values(rawOption);
        return firstValue;
    }
    if (descriptor.typeOptions && !descriptor.typeOptions.multipleValues) {
        return rawOption[descriptor.name] || {};
    }
    return rawOption;
}
function parseCollectionOptions(descriptor, rawOption) {
    var _a;
    const results = {};
    if (descriptor.type !== 'collection') {
        return rawOption;
    }
    for (const option of (_a = descriptor === null || descriptor === void 0 ? void 0 : descriptor.options) !== null && _a !== void 0 ? _a : []) {
        if (!option.name || typeof rawOption[option.name] === 'undefined') {
            continue;
        }
        if (isINodeProperties(option) && (option === null || option === void 0 ? void 0 : option.type) === 'fixedCollection') {
            results[option.name] = parseFixedCollectionOptions(option, rawOption[option.name]);
        }
        else {
            results[option.name] = rawOption[option.name];
        }
    }
    return results;
}
function isINodeProperties(descriptor) {
    return descriptor.type !== undefined;
}
function flaternScrapedResults(options, data) {
    const results = [];
    for (const dat of data) {
        for (const res of dat.results) {
            const resFlat = {
                selector: dat.selector,
                url: options.options.url,
                ...res,
            };
            results.push(resFlat);
        }
    }
    return results;
}
//# sourceMappingURL=GenericFunctions.js.map