"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Browserless = void 0;
const Browserless_properties_1 = require("./Browserless.properties");
const Browserless_methods_1 = require("./Browserless.methods");
class Browserless {
    constructor(baseDescription) {
        this.methods = Browserless_methods_1.methods;
        this.description = {
            ...baseDescription,
            displayName: 'Browserless',
            name: 'browserless',
            icon: 'file:browserless.svg',
            group: ['transform'],
            version: 2,
            subtitle: '={{$parameter["operation"] + ": " + $parameter["resource"]}}',
            description: 'Browserless API',
            defaults: {
                name: 'Browserless',
            },
            inputs: ['main'],
            outputs: ['main'],
            credentials: [
                {
                    displayName: 'Browserless API',
                    name: 'browserlessApi',
                    required: true,
                },
            ],
            requestDefaults: {
                headers: {
                    'Content-Type': 'application/json',
                },
                baseURL: '={{$credentials.url}}',
            },
            properties: Browserless_properties_1.properties,
        };
    }
}
exports.Browserless = Browserless;
//# sourceMappingURL=Browserless.node.js.map