"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.properties = exports.option = exports.name = void 0;
const properties_1 = require("./properties");
const hooks_1 = require("./hooks");
exports.name = 'Content';
const rawOption = {
    name: 'Content',
    value: 'Content',
    action: 'Content',
    description: 'A JSON-based API. Given a "url" or "html" field, runs and returns HTML content after the page has loaded and JavaScript has parsed',
    routing: {
        request: {
            method: 'POST',
            url: '=/content',
        },
        output: {
            postReceive: [
                {
                    type: 'setKeyValue',
                    properties: {
                        data: '={{$response.body}}',
                    },
                },
            ],
        },
    },
};
const { properties, option } = (0, hooks_1.runHooks)(rawOption, properties_1.properties);
exports.properties = properties;
exports.option = option;
//# sourceMappingURL=index.js.map