"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.properties = exports.option = exports.name = void 0;
const properties_1 = require("./properties");
const hooks_1 = require("./hooks");
exports.name = 'Download';
const rawOption = {
    name: 'Download',
    value: 'Download',
    action: 'Download',
    description: 'A JSON or JavaScript content-type API for returning files Chrome has downloaded during the execution of puppeteer code, which is ran inside context of the browser. Browserless sets up a blank page, a fresh download directory, injects your puppeteer code, and then executes it. You can load external libraries via the "import" syntax, and import ESM-style modules that are written for execution inside of the browser. Once your script is finished, any downloaded files from Chromium are returned back with the appropriate content-type header',
    routing: {
        request: {
            method: 'POST',
            url: '=/download',
        },
        output: {
            postReceive: [
                {
                    type: 'setKeyValue',
                    properties: {
                        data: '={{$response.body}}',
                    },
                },
            ],
        },
    },
};
const { properties, option } = (0, hooks_1.runHooks)(rawOption, properties_1.properties);
exports.properties = properties;
exports.option = option;
//# sourceMappingURL=index.js.map