"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.properties = exports.option = exports.name = void 0;
const properties_1 = require("./properties");
const hooks_1 = require("./hooks");
exports.name = 'Execute';
const rawOption = {
    name: 'Execute',
    value: 'Execute',
    action: 'Execute',
    description: 'A JSON or JavaScript content-type API for running puppeteer code in the browser\'s context. Browserless sets up a blank page, injects your puppeteer code, and runs it. You can optionally load external libraries via the "import" module that are meant for browser usage. Values returned from the function are checked and an appropriate content-type and response is sent back to your HTTP call',
    routing: {
        request: {
            method: 'POST',
            url: '=/function',
        },
        output: {
            postReceive: [
                {
                    type: 'setKeyValue',
                    properties: {
                        data: '={{$response.body}}',
                    },
                },
            ],
        },
    },
};
const { properties, option } = (0, hooks_1.runHooks)(rawOption, properties_1.properties);
exports.properties = properties;
exports.option = option;
//# sourceMappingURL=index.js.map