"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.properties = exports.option = exports.name = void 0;
const properties_1 = require("./properties");
const hooks_1 = require("./hooks");
exports.name = 'Pdf';
const rawOption = {
    name: 'Pdf',
    value: 'Pdf',
    action: 'Pdf',
    description: 'A JSON-based API for getting a PDF binary from either a supplied "url" or "html" payload in your request. Many options exist for injecting cookies, request interceptors, user-agents and waiting for selectors, timers and more',
    routing: {
        request: {
            method: 'POST',
            url: '=/pdf',
            encoding: 'arraybuffer',
        },
        output: {
            postReceive: [
                {
                    type: 'binaryData',
                    properties: {
                        destinationProperty: 'data',
                    },
                },
            ],
        },
    },
};
const { properties, option } = (0, hooks_1.runHooks)(rawOption, properties_1.properties);
exports.properties = properties;
exports.option = option;
//# sourceMappingURL=index.js.map